#ifndef _query_browse_h_
#define _query_browse_h_

#include "types.h"
#include "dn_list.h"
#include "error.h"

/**************************************************
 *
 * User result structure.
 * 
 */

typedef struct _browse_results
{
  QBool success;
  char *baseobject;
  entryList entries;
  errorList errors;
} browse_results, *browseResults;

#define NULLBrowseResults (browseResults) NULL
#define browse_res_alloc() (browseResults) smalloc(sizeof(browse_results))

/**************************************************
 *
 * Internal request record.
 * 
 */

typedef struct _browse_rec
{
  QCardinal request_id;
  int task_id;
  char *baseobject;
  browseResults results;
} browse_rec, *browseRec;

#define NULLBrowseRec (browseRec) NULL
#define browse_rec_alloc() (browseRec) smalloc(sizeof(browse_rec))

/**************************************************
 *
 * Public functions.
 * 
 */

QE_error_code do_browse();

request_state process_browse_ds_result(),
              process_browse_ds_error();

browseResults get_browse_results();

void browse_results_free();
void browse_rec_free();

#endif /* _query_browse_h_ */
