#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/actions.c,v 1.0 92/11/27 16:59:28 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/actions.c,v 1.0 92/11/27 16:59:28 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  actions.c - Functions to collate and manage actions associated with windows.

*****************************************************************************/

#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>

#include "defs.h"
#include "windows.h"
#include "actions.h"
#include "objects.h"
#include "layout.h"
#include "configure.h"
#include "xutil.h"
#include "y.tab.h"

/***************************************************
 *
 *	Globals...
 *
 */

Cardinal action_number = 0;
objectAction actions[MAXACTIONS];

/***************************************************
 *
 *	Externals....
 *
 */

extern Display *dpy;
extern windowObject win_objects[];
extern windowTemplate win_templates[];
extern XContext action_cid, prim_type_cid, object_cid;

extern void doAbortRequest();

/***************************************************
 *
 *	Local funcs...
 *
 */

static void doPrimitiveSensitivityAux();

/*****************************************************************************
 * initContexts()
 *
 * 
 *
 ****************************************************************************/

void initContexts(template, tree, object_id)
     WidgetTree tree;
     layoutMember template;
     Cardinal object_id;
{
  layoutMember sub_template;
  Widget this_widget, active;
  Arg args[MAXARGS];
  Cardinal count;
  actionID action_id;

  while (template != NULLLayout)
    {
      if (template->ref == REF_layout)
	{
	  sub_template =
	    win_templates[template->reference.layout_ref_id]->layout;

	  initContexts(sub_template, tree->descendants, object_id);
	}
      else
	{
	  if (template->action_list != NULLPrimActionList)
	    action_id = template->action_list->prim_action_id;
	  else
	    action_id = ActionUndefined;

	  this_widget = tree->this_widget;

	  switch (template->reference.primitive_id)
	    {
	    case BUTTON:

	      initPrimAction(this_widget, object_id, action_id, BUTTON);
	      break;

	    case MOVETO:
	      
	      active = XtNameToWidget(this_widget, "movetoDialog");
	      initPrimAction(active, object_id, action_id, MOVETO);
	      
	      break;

	    case ENTRY_LIST:

	      active = XtNameToWidget(this_widget, "listForm");
	      initPrimAction(active, object_id, action_id, ENTRY_LIST);

	      break;

	    case LOOKUP:

	      initPrimAction(this_widget, object_id, action_id, LOOKUP);
	      
	      active = XtNameToWidget(this_widget, "lastTypeDialog");
	      initPrimAction(active, object_id, action_id, LOOKUP);

	      while (lexequ(XtName(active), "firstTypeDialog") != 0)
		{
		  count = 0;
		  XtSetArg(args[count], XtNfromVert, &active); count++;
		  XtGetValues(active, args, count);

		  initPrimAction(active, object_id, action_id, LOOKUP);
		}

	      break;
	    }
	}

      /***************************************************
       *
       * Other context initializers
       * (this may be the wrong place to put this).
       *
       */

      if (template->ref == REF_primitive)
	{
	  extern void initModifyStatusData();

	  this_widget = tree->this_widget;

	  switch (template->reference.primitive_id)
	    {
	    case MODIFY:
	      
	      initModifyStatusData(this_widget);
	      break;
	    }
	}

      template = template->next_layout;
      tree = tree->left_siblings;
    }
} /* initContexts */

/*****************************************************************************
 * initPrimAction()
 *
 * 
 *
 ****************************************************************************/

void initPrimAction(widget, object_id, action_id, prim_id)
     Widget widget;
     Cardinal object_id;
     actionID action_id;
     Cardinal prim_id;
{
  XLUaddContextEntry(widget, action_cid, (caddr_t) action_id, NULLWidget);
  XLUaddContextEntry(widget, object_cid, (caddr_t) object_id, NULLWidget);
  XLUaddContextEntry(widget, prim_type_cid, (caddr_t) prim_id, NULLWidget);
} /* initPrimAction */

/*****************************************************************************
 * findOutputObject()
 *
 * 
 *
 ****************************************************************************/

Widget findOutputObject(originator_id, output_template_id, mode, output_id_ptr)
     Cardinal originator_id;
     Cardinal output_template_id;
     outputMode mode;
     Cardinal *output_id_ptr;
{
  Widget output_shell = NULLWidget;

  switch (mode)
    {
    case NewWhenKeptLocal:

      *output_id_ptr = find_unkept_child(originator_id, output_template_id);

      if (*output_id_ptr < MAXWINDOWS)
	{
	  output_shell = win_objects[*output_id_ptr]->parent_shell;
	  XRaiseWindow(dpy, XtWindow(output_shell));
	}
      else
	{
	  output_shell = make_object(output_template_id,
				     NULLWidget,
				     &originator_id,
				     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenKeptGlobal:

      *output_id_ptr = find_unkept_object(output_template_id);

      if (*output_id_ptr < MAXWINDOWS)
	{
	  output_shell = win_objects[*output_id_ptr]->parent_shell;
	  XRaiseWindow(dpy, XtWindow(output_shell));
	}
      else
	{
	  output_shell = make_object(output_template_id,
				     NULLWidget,
				     &originator_id,
				     output_id_ptr);

	  XtRealizeWidget(output_shell);
	  XtPopup(output_shell, XtGrabNone);
	}

      break;

    case NewWhenNone:

      /* ## To do ## */
      break;
      
    case CurrentWin:

      *output_id_ptr = originator_id;
      output_shell = win_objects[*output_id_ptr]->parent_shell;

      XRaiseWindow(dpy, XtWindow(output_shell));
      break;

    case NewAlways:

      output_shell = make_object (output_template_id,
				  NULLWidget,
				  &originator_id,
				  output_id_ptr);

      XtRealizeWidget(output_shell);
      XtPopup(output_shell, XtGrabNone);

      break;
    }

  doPrimitiveSensitivity(*output_id_ptr);

  /***************************************************
   *
   * If there are requests outstanding
   * then abandon these.
   *
   */

  doAbortRequest(NULLWidget, *output_id_ptr,0, ActionUndefined, NULLTransList);
  return output_shell;
} /* findOutputObject */

/*****************************************************************************
 * doPrimitiveSensitivity()
 *
 * 
 *
 ****************************************************************************/

void doPrimitiveSensitivity(object_id)
     Cardinal object_id;
{
  windowObject this_object = win_objects[object_id];
  WidgetTree curr_widget = this_object->widget_layout->descendants;
  layoutMember curr_member = win_templates[this_object->template_id]->layout;
  char object_state = 0;

  if (isWaiting(object_id) == TRUE)
    object_state = I_DS_WAIT;
  else
    object_state = I_NORMAL;
  
  if (this_object->current_entry == NULLCP ||
      *this_object->current_entry == '\0')
    object_state = object_state | I_NO_ENTRY;

  if (this_object->current_list == NULLEntryList)
    object_state = object_state | I_NO_LIST;

  if (this_object->current_errors == NULLError)
    object_state = object_state | I_NO_ERROR;
  
  doPrimitiveSensitivityAux(curr_member, curr_widget, object_state);
} /* doPrimitiveSensitivity */

/*****************************************************************************
 * doPrimitiveSensitivityAux()
 *
 * 
 *
 ****************************************************************************/

static void doPrimitiveSensitivityAux(curr_member,
				      curr_widget,
				      object_state)
     layoutMember curr_member;
     WidgetTree curr_widget;
     char object_state;
{
  char insensitivity;
  Widget prim_widget;

  while (curr_member != NULLLayout)
    {
      switch (curr_member->ref)
	{
	case REF_layout:
	  
	  doPrimitiveSensitivityAux
	    (win_templates[curr_member->reference.layout_ref_id]->layout,
	     curr_widget->descendants,
	     object_state);
	  
	  break;

	case REF_primitive:
	  
	  prim_widget = curr_widget->this_widget;
	  insensitivity = curr_member->insensitivity;
	  
	  if ((insensitivity & object_state) != 0)
	    {
	      if (XtIsSensitive(prim_widget) == TRUE) 
		XtSetSensitive(prim_widget, FALSE);
	    }
	  else
	    {
	      if (XtIsSensitive(prim_widget) == FALSE)
		XtSetSensitive(prim_widget, TRUE);
	    }
	  
	  break;
	}

      curr_member = curr_member->next_layout;
      curr_widget = curr_widget->left_siblings;
    }
} /* doPrimitiveSensitivityAux */

/*****************************************************************************
 * getActionByName()
 *
 * 
 *
 ****************************************************************************/

actionID getActionByName(name)
     String name;
{
  objectAction action;
  actionID id;
  
  for (id = 0; id < action_number;  id++)
    {
      action = actions[id];
      if (lexequ(action->action_name, name) == 0)
	{
	  return id;
	}
    }

  return ActionUndefined;
} /* getActionByName */
