#ifndef lint
static char *rcsid = "";
#endif

/* $Header: /a/Pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/xdir/RCS/help_display.c,v 0.97 91/09/05 13:26:01 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  help.c - Display help in the form of text and/or a bitmap

*****************************************************************************/

#include "defs.h"

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>

#include "query.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "help.h"

/***************************************************
 *
 * Externals.
 *
 */

extern char bitmap_directory[];

/***************************************************
 *
 * Global data.
 *
 */

char help_directory[LINESIZE];

/***************************************************
 *
 * Local data.
 *
 */

static char file_path[LINESIZE];

/*****************************************************************************
 * setHelp()
 *
 * 
 *
 ****************************************************************************/

void setHelp(help_widget, template)
     Widget help_widget;
     layoutMember template;
{
  Widget text_widget, bitmap_widget, form;
  String filename;

  Arg args[MAXARGS];
  Cardinal count;

  int width, height;

  PS ps;
  FILE *helpfile;
  static char buffer[LINESIZE];
  String help_text;

  form = XtNameToWidget(help_widget, "helpViewForm");
  
  text_widget = XtNameToWidget(form, "helpText");
  bitmap_widget = XtNameToWidget(form, "helpBitmap");

  XawFormDoLayout(form, FALSE);
  XtUnmanageChild(bitmap_widget);

  filename = template->bitmap_file;
  if (!isemptystr(filename))
    {
      (void) sprintf(file_path, "%s%s", bitmap_directory, filename);
      create_background_from_bitmap_file(bitmap_widget, file_path);
    }

  filename = template->help_file;
  if (!isemptystr(filename))
    {
      if ((ps = ps_alloc(str_open)) == NULLPS)
	return;

      if (str_setup(ps, NULLCP, 0, 0) == NOTOK)
	{
	  ps_free(ps);
	  return;
	}

      (void) sprintf(file_path, "%s%s", help_directory, filename);

      if ((helpfile = fopen(file_path, "r")) == NULL)
	{
	  (void) fprintf(stderr,
			 "Error : Could not open help file `%s'\n",
			 file_path);
	  
	  ps_free(ps);
	  return;
	}

      while (fgets(buffer, LINESIZE - 1, helpfile) != NULL)
	ps_printf(ps, "%s", buffer);

      help_text = ps->ps_base;
      *ps->ps_ptr = '\0';

      count = 0;
      XtSetArg(args[count], XtNstring, help_text); count++;
      XtSetValues(text_widget, args, count);

      ps_free(ps);
    }
  else
    {
      XawFormDoLayout(form, TRUE);
      XtManageChild(bitmap_widget);
    }

  XawFormDoLayout(form, TRUE);

  get_text_dims(help_text, text_widget, &height, &width);
  count = 0;
  
  XtSetArg(args[count], XtNheight, (Dimension) height); count++;
  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
  
  XtSetValues(text_widget, args, count);
  XtManageChild(bitmap_widget);
} /* setHelp */

