#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/main.c,v 1.0 92/11/27 17:00:12 emsrdsm Exp Locker: emsrdsm $";
#endif

/******************************************************************************
 
  main.c 

******************************************************************************/

#include "defs.h"
#include "windows.h"
#include "objects.h"
#include "interact.h"
#include "widgets.h"
#include "configure.h"
#include "update1.h"
#include "showentry.h"

#include "query.h"
#include "init.h"

#include <manifest.h>

#ifdef USE_PP
#include "or.h"
#endif

#include <varargs.h>

/***************************************************
 *
 * Externals.
 *
 */

extern Boolean testing;
extern QBool use_poor_matches;

int fprintf();

/***************************************************
 *
 * Local functions.
 *
 */

static void read_args();

/***************************************************
 *
 * Public functions.
 *
 */

void quit();
int advise();

/***************************************************
 *
 * Global storage.
 *
 */

Widget toplevel;
XtAppContext app_context;
Display *dpy;
char XLUresfile[LINESIZE];

String resource_class = "Xlookup", program_name = "xlu";
XContext context_id, mod_focus_cid, mod_group_focus_cid, mod_has_focus_cid;

/*****************************************************************************
 * main()
 *
 * 
 *
 ****************************************************************************/

int main(argc, argv)
     int argc;
     char *argv[];
{
  extern time_t cache_timeout;
  extern QBool want_photo_as_bytes, want_audio_as_bytes;

  toplevel = XtAppInitialize(&app_context,
			     resource_class, 
			     NULL,
			     0,
			     &argc, argv,
			     NULL,
			     NULL,
			     0);

  dpy = XtDisplay(toplevel);

  /***************************************************
   *
   * Initialize widget stuff.
   *
   */

  initWidgets(app_context);

  /***************************************************
   *
   * Get context ids.
   *
   */

  context_id = XUniqueContext();
  initModContexts();
  initReadContexts();

  /***************************************************
   *
   * Parse non-DS and non-X arguments
   *
   */

  read_args(argc, argv);

  /***************************************************
   *
   * Initialize DS stuff.
   *
   */

  have_iso8859_font();

  want_photo_as_bytes = TRUE;
  want_audio_as_bytes = TRUE;

  use_poor_matches = FALSE;
  init_query_engine(argc, argv);

  *XLUresfile = '\0';
  user_tailor();

  if (!isnull(*XLUresfile))
    {
      XrmDatabase readdb = (XrmDatabase) NULL;
      char filename[LINESIZE];
      extern char config_directory[];

      if (*XLUresfile != '/' && *XLUresfile != '~')
	{
	  (void) sprintf(filename, "%s%s", config_directory, XLUresfile);
	}
      else
	{
	  (void) strcpy(filename, XLUresfile);
	}

      readdb = XrmGetFileDatabase(filename);
      if (readdb != (XrmDatabase) NULL)
	{
	  XrmMergeDatabases(readdb, &(dpy->db));
	}
    }

  /***************************************************
   *
   * Initialize OR stuff.
   *
   */

#ifdef USE_PP
  or_init();
#endif /* USE_PP */

  /***************************************************
   *
   * Set cache timeout for 30 minutes. Should
   * be configurable!
   */

  cache_timeout = 10 * 60;

  /***************************************************
   *
   * Bind to DS.
   *
   */

  if (bind_to_ds(argc, argv, SIMPLE_AUTH) == FALSE)
    xluFatal("Couldn't connect to the directory!");

  create_startup_windows();

  XLUuserInteract();
  return 0;
} /* main */

/*****************************************************************************
 * read_args()
 *
 * 
 *
 ****************************************************************************/

static void read_args(argc, argv)
     int argc;
     char *argv[];
{
  char *cp;
  extern Boolean testing;

  extern char config_file_name[];

  if (argc <= 1)
    return;

  argc--;
  argv++;

  while (argc-- > 0 && ((cp = *argv++) != NULLCP))
    {
      if (*cp == '-')
	{
	  switch (*++cp)
	    {
	    case 'l':
	    case 'L':

	      /**************************************************
	       *
	       * Load a named configuration file.
	       * 
	       */
	      
	      if (argc >= 1)
		{
		  cp = *argv++;
		  
		  if (*cp == '-')
		    xluFatal("Invalid command line syntax.");
		  
		  (void) strcpy(config_file_name, cp);
		  argc--;
		}
	      else
		xluFatal("Invalid command line syntax.");
	      
	      break;
	      
	    case 't':

	      /**************************************************
	       *
	       * Testing prior to installation.
	       * 
	       */
	      
	      if (lexequ(cp, "test") == 0)
		testing = TRUE;
	      
	      default:
	      break;
	    }
	}
    }
} /* read_args */
