#ifndef _Xlu_objects_h_
#define _Xlu_objects_h_

#include "defs.h"
#include "windows.h"
#include "layout.h"

#include <dn_list.h>
#include <query.h>

#define MAXWINDOWS 64
#define MAXSTARTS 64

typedef struct widget_tree
{
  Widget this_widget;
  ReferenceType reference;

  struct widget_tree *descendants;
  struct widget_tree *left_siblings;
} *WidgetTree;

#define NULLWidgetTree (WidgetTree) NULL
#define WidgetTree_alloc() (WidgetTree) XtMalloc(sizeof(struct widget_tree))

typedef struct child_object
{
  Cardinal child_object_id;

  struct child_object *left_siblings;
} child_list, *childList;
  
#define NULLChildList (childList) NULL
#define child_list_alloc() (childList) XtMalloc(sizeof(child_list))

typedef struct
{
  Cardinal template_id;

  Boolean is_child;
  Cardinal parent_object_id;

  Boolean is_kept;

  Widget parent_shell;
  WidgetTree widget_layout;

  childList children;
  Cardinal num_children;

  String current_entry;
  entryList current_list;
  entryList current_save_list;
  errorList current_errors;
} window_object, *windowObject;

#define NULLWinObject (windowObject) NULL
#define object_alloc() (windowObject) XtMalloc(sizeof(window_object))

/***************************************************
 *
 * Global functions.
 *
 */

void set_current_entry();
void set_current_errors();

void set_current_list();
void set_current_save_list();

Boolean isWaiting();
void XLUwait();

void create_startup_windows();
void free_child_list();

void free_widget_tree();
void delete_win_object();

Cardinal find_unkept_child();
Cardinal find_unkept_object();

Widget make_object();
Cardinal get_object_id();

#endif /* _Xlu_objects_h_ */



