#ifndef _Xlu_requests_h_
#define _Xlu_requests_h_

#include "defs.h"
#include "windows.h"
#include "actions.h"
#include "query.h"

typedef void (*DSResultCallback)();
typedef void (*DSReportCallback)();

typedef struct _assoc_rec
{
  QCardinal request_id;
  request_type type;

  DSResultCallback result_cb;
  DSReportCallback report_cb;

  XtInputId input_id;
  int assoc_desc;

  Widget this_widget;
  Cardinal object_id;
  Cardinal prim_id;

  actionID action_id;
  translationList trans_list;

  struct _assoc_rec *next;
} assoc_rec, *assocRec;

#define assoc_rec_alloc() (assocRec) XtMalloc(sizeof(assoc_rec))
#define NULLAssocRec (assocRec) NULL

/***************************************************
 *
 * Public functions..
 *
 */

void request_complete();
void request_invoked();

#endif /* _Xlu_requests_h_ */
