#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/showentry.c,v 1.0 92/11/27 17:00:36 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/showentry.c,v 1.0 92/11/27 17:00:36 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  showentry.c - Display directory entries

*****************************************************************************/

#include "defs.h"

#include <X11/Xatom.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>

#include <signal.h>
#include <errno.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"
#include "requests.h"

#include "status.h"
#include "errview.h"
#include "showentry.h"

#include "mua_selection.h"

#ifdef  BSD42
#include <sys/wait.h>
#endif

#ifdef USE_PP
#include "or.h"
#endif

#ifndef BINPATH
#define BINPATH "/usr/local/bin/"
#endif

/***************************************************
 *
 * Externals.
 *
 */

extern windowObject win_objects[];
extern objectAction actions[];
extern Display *dpy;
extern XContext action_cid, prim_type_cid, object_cid;

/***************************************************
 *
 * Local functions.
 *
 */

static void doRead();
static void doReadSeeAlso();
static void addNameAndValueStrings();
static void addDnSelectButton();

static void selectMailAddress();
static int LoseDUA();
static int ConvertDUA();
static void DisownDUA();

/***************************************************
 *
 * Audio only works for Sparc.
 *
 */

#if defined(sparc) && defined(SUNOS41)

static void addAudioPlayButton();
static void playAudio();
static void freeAudioData();

#endif // defined(sparc) && defined(SUNOS41)

/***************************************************
 *
 * Global storage.
 *
 */

readAttribute attrs_to_display = NULLReadAttribute;
Widget curr_selection_owner = NULLWidget, last_selection_owner = NULLWidget;

/***************************************************
 *
 * Local storage.
 *
 */

static char select_name[LINESIZE],
            select_dn[LINESIZE],
	    select_mail[LINESIZE],
	    select_phone[LINESIZE];

static XContext store_attr_cid;

/*****************************************************************************
 * initReadContexts()
 *
 * 
 *
 ****************************************************************************/

void initReadContexts()
{
  store_attr_cid = XUniqueContext();
} /* initReadContexts */

/*****************************************************************************
 * displayCurrentEntry()
 *
 * 
 *
 ****************************************************************************/

void displayCurrentEntry(prim_widget,
			 object_id,
			 prim_id,
			 action_id,
			 trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  WidgetList prim_insts;
  
  prim_insts = findPrimitiveInstances(object_id, READ_OUT);

  if (prim_insts != (Widget *) NULL)
    {
      doRead(prim_widget, object_id, prim_id, action_id, trans_list);
      XtFree((char *) prim_insts);
    }
} /* displayCurrentEntry */

/*****************************************************************************
 * gotReadResult()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void gotReadResult(request_id, object_id, action_id, trans_list)
     Cardinal request_id;
     Cardinal object_id;
     actionID action_id;
     translationList trans_list;
{
  readResults result;
  WidgetList prim_insts;
  char err_msg[LINESIZE], entry_name[LINESIZE];

  XBell(dpy, 40);

  setStatusMessage(object_id, "Read result received.");
  result = get_read_results(request_id);

  request_complete(request_id);
  doPrimitiveSensitivity(object_id);

  if (result->entry == NULLAVList)
    /**************************************************
     *
     * Read failed. Set and display errors.
     * 
     */
    {
      if (result->errors != NULLError)
	{
	  friendlify(result->errors->baseobject, entry_name);
	  (void) sprintf(err_msg,
			 "Couldn't read `%.24s..' because;\n%s",
			 entry_name,
			 get_message_of_code(result->errors->error_type));

	  setStatusMessage(object_id, err_msg);
	}
      else
	setStatusMessage(object_id, "Nothing found!");
    }
  else
    /**************************************************
     *
     * Read succeeded.
     * 
     */
    {
      
      prim_insts = findPrimitiveInstances(object_id, READ_OUT);

      if (prim_insts != (Widget *) NULL)
	{
	  updateReadDisplay(object_id,
			    prim_insts[0],
			    result->entry,
			    result->errors,
			    result->base_object);

	  set_current_entry(object_id, result->base_object);
	  
	  XtFree((char *) prim_insts);
	  setStatusMessage(object_id, "");
	}
    }

  /**************************************************
   *
   * Check errors.
   * 
   */
  
  set_current_errors(object_id, result->errors);
  if (result->errors != NULLError)
    {
      result->errors = NULLError;
      updateErrorViewer(object_id);
    }

  /**************************************************
   *
   * All done.
   * 
   */

  read_result_free(&result);
} /* gotReadResult */

/*****************************************************************************
 * updateReadDisplay()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void updateReadDisplay(object_id, widget, aventry, errors, dn)
     Cardinal object_id;
     Widget widget;
     attrValList aventry;
     errorList errors;
     String dn;
{
  Dimension namewidth = 0, height, maxwidth = 0;
  attrValList curr_attr;
  Widget types, values, photo_widget, form, select_button,
         vscroll, hscroll, entry_label, tmpwidget, prev;
  static String scrollback = "Backward",
                fullscroll = "FullLength";
  XEvent event;
  Arg args[MAXARGS];
  Cardinal count, linecount = 0;
  PS valps, nameps;
  AttributeType curr_type,
                text_or_type = AttrT_new("0.9.2342.19200300.100.1.2"),
                mail_type = AttrT_new("0.9.2342.19200300.100.1.3"),
                phone_type = AttrT_new("2.5.4.20");
  char buffer[LINESIZE],
       or_addr[LINESIZE],
       name[LINESIZE],
       phone[LINESIZE],
       mail_addr[LINESIZE];
  photoData photo_data;
  XFontStruct *font;
  Screen *screen = XtScreen(widget);
  Pixmap photo_pixmap, old_pixmap;
  register readAttribute curr_display_attr;
  short dn_syntax, photo_syntax, audio_syntax;
  XtCallbackList callbacks;
  Boolean photo_done = FALSE;

#if defined(sparc) && defined(SUNOS41)
  audioData audio_data;
#endif
  
  or_addr[0] = name[0] = phone[0] = mail_addr[0]= '\0';
  friendlify(dn, name);

  dn_syntax = AttrT_new("2.5.4.34")->oa_syntax;
  photo_syntax = AttrT_new("0.9.2342.19200300.100.1.7")->oa_syntax;
  audio_syntax = AttrT_new("audio")->oa_syntax;

  /**************************************************
   *
   * valps used to store attribute value strings,
   * nameps used to store attribute type names.
   * 
   */

  if ((valps = ps_alloc(str_open)) == NULLPS)
    return;

  if ((nameps = ps_alloc(str_open)) == NULLPS)
    {
      ps_free(valps);
      return;
    }
  
  if (str_setup(valps, NULLCP, 0, 0) == NOTOK)
    {
      ps_free(valps);
      ps_free(nameps);

      return;
    }

  if (str_setup(nameps, NULLCP, 0, 0) == NOTOK)
    {
      ps_free(valps);
      ps_free(nameps);

      return;
    }

  form = XtNameToWidget(widget, "readForm");
  types = XtNameToWidget(form, "readTypes");
  values = XtNameToWidget(form, "readValues");

  entry_label = XtNameToWidget(form, "entryName");
  select_button = XtNameToWidget(form, "selectForMUA");

  friendlify(dn, buffer);

  count = 0;
  XtSetArg(args[count], XtNlabel, buffer); count++;
  XtSetValues(entry_label, args, count);

  count = 0;
  XtSetArg(args[count], XtNfont, &font); count++;
  XtGetValues(values, args, count);

  count = 0;
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNstring, ""); count++;

  XtSetValues(types, args, count);
  XtSetValues(values, args, count);

  /**************************************************
   *
   * Clear the old photo
   * 
   */

  photo_widget = XtNameToWidget(form, "photo");

  XtSetArg(args[0], XtNbackgroundPixmap, &old_pixmap);
  XtGetValues(photo_widget, args, 1);

  count = 0;
  XtSetArg(args[count], XtNbackgroundPixmap, XtUnspecifiedPixmap); count++;

  XtSetArg(args[count], XtNborderWidth, (Dimension) 0); count++;
  XtSetArg(args[count], XtNborderColor, WhitePixelOfScreen(screen)); count++;

  XtSetArg(args[count], XtNinternalWidth, (Dimension) 0); count++;
  XtSetArg(args[count], XtNinternalHeight, (Dimension) 0); count++;

  XtSetValues(photo_widget, args, count);

  if (old_pixmap != XtUnspecifiedPixmap)
    {
      count = 0;
      XtSetArg(args[count], XtNbackgroundPixmap, XtUnspecifiedPixmap); count++;
      XtSetValues(photo_widget, args, count);
      
      XFreePixmap(dpy, old_pixmap);
    }

  XtUnmanageChild(photo_widget);

  /**************************************************
   *
   * Remove buttons and text associated with old
   * active attributes.
   *
   */

  XtSetArg(args[0], XtNfromHoriz, &prev);

  while ((tmpwidget = XtNameToWidget(form, "attrText")) != NULLWidget)
    {
      XtGetValues(tmpwidget, args, 1);
      
      XtUnmanageChild(tmpwidget);
      XtDestroyWidget(tmpwidget);
      
      XtUnmanageChild(prev);
      XtDestroyWidget(prev);
    }

  if ((tmpwidget = XtNameToWidget(form, "audioButton")) != NULLWidget)
    {
      XtUnmanageChild(tmpwidget);
      XtDestroyWidget(tmpwidget);
    }

  /******************************************************************
   *
   * Put all strings values into the correct PStream,
   * pairs,
   * Photos are displayed immediately,
   * Sounds are stored for later playing
   * Sounds stored under callback closure (for destroy and button)
   * Other file attributes freed immediately!
   *
   */

  prev = NULLWidget;

  for (curr_display_attr = attrs_to_display;
       curr_display_attr != NULLReadAttribute;
       curr_display_attr = curr_display_attr->next)
    {
      for (curr_attr = aventry;
	   curr_attr != NULLAVList;
	   curr_attr = curr_attr->next)
	{
	  curr_type = AttrT_new(curr_attr->attr_name->string);
	      
	  if (curr_type == curr_display_attr->type)
	    {
	      if (curr_type->oa_syntax == dn_syntax)
		/***************************************************
		 *
		 * Create a button and text pair for DN attributes
		 *
		 */
		{
		  addDnSelectButton(curr_attr, object_id, widget, &prev);
		}
	      else if (photo_done == FALSE &&
		       curr_attr->syntax == photo_syntax &&
		       curr_attr->data.photo->width != 0)
		{
		  photo_done = TRUE;
		  photo_data = curr_attr->data.photo;
		  
		  photo_pixmap = XCreatePixmapFromBitmapData
		    (dpy,
		     XtWindow(photo_widget),
		     (char *) photo_data->bytes,
		     (Cardinal) photo_data->width,
		     (Cardinal) photo_data->height,
		     BlackPixelOfScreen(screen),
		     WhitePixelOfScreen(screen),
		     DefaultDepthOfScreen(screen));
		  
		  count = 0;
		  
		  XtSetArg(args[count],
			   XtNwidth,
			   (Dimension) photo_data->width); count++;
		  
		  XtSetArg(args[count],
			   XtNheight,
			   (Dimension) photo_data->height); count++;
		  
		  XtSetArg(args[count], XtNborderWidth, 1); count++;
		  
		  XtSetArg(args[count],
			   XtNbackgroundPixmap,
			   photo_pixmap); count++;
		  
		  XtSetArg(args[count],
			   XtNborderColor,
			   BlackPixelOfScreen(screen)); count++;
		  
		  XtSetArg(args[count],
			   XtNinternalWidth,
			   (Dimension) 1); count++;
		  
		  XtSetArg(args[count],
			   XtNinternalHeight,
			   (Dimension) 1); count++;
		  
		  XtSetValues(photo_widget, args, count);

		  curr_attr->data.photo = NULLPhotoData;
		}

	      /***************************************************
	       *
	       * If sound, add a button that allows this to be
	       * played
	       */

#if defined(sparc) && defined(SUNOS41)
	      else if (curr_attr->syntax == audio_syntax)
		{
		  audio_data = curr_attr->data.audio;
		  addAudioPlayButton(audio_data, widget, &prev);
		  curr_attr->data.audio = NULLAudioData;
		}

#endif // defined(sparc) && defined(SUNOS41)
	      else
		addNameAndValueStrings(nameps,
				       valps,
				       font,
				       curr_attr,
				       curr_display_attr->to_show,
				       &maxwidth,
				       &namewidth,
				       &linecount);
	    }

	  /***************************************************
	   *
	   * These attributes are saved for user selection
	   *
	   */

	  if (curr_type == text_or_type && *or_addr == '\0')
	    (void) strcpy(or_addr, curr_attr->val_list->string);
	  else if (curr_type == mail_type && *mail_addr == '\0')
	    (void) strcpy(mail_addr, curr_attr->val_list->string);
	  else if (curr_type == phone_type && *phone == '\0')
	    (void) strcpy(phone, curr_attr->val_list->string);
	}
    }

  if (valps->ps_ptr != NULL)
    *valps->ps_ptr = NULL;
  
  if (nameps->ps_ptr != NULL)
    *(nameps->ps_ptr) = NULL;

  maxwidth += (FONTWIDTH(font) * 4);
  namewidth += (FONTWIDTH(font) * 2);

  height = ++linecount * FONTHEIGHT(font);

  /**************************************************
   *
   * Add strings in nameps and valps buffers
   * to text widgets, and set appropriate
   * dimensions.
   * 
   */

  count = 0;

  XtSetArg(args[count], XtNstring, (String) valps->ps_base); count++;
  XtSetValues(values, args, count);

  set_widget_dimensions(values, maxwidth, height);

  count = 0;

  XtSetArg(args[count], XtNstring, (String) nameps->ps_base); count++;
  XtSetValues(types, args, count);

  set_widget_dimensions(types, namewidth, height);

  ps_free(valps);
  ps_free(nameps);

  /**************************************************
   *
   * Re-enable update in text widgets and force 
   * re-layout.
   * 
   */

  XawFormDoLayout(form, TRUE);
  XtManageChild(photo_widget);

  /**************************************************
   *
   * Resize scrollbar
   * 
   */

  hscroll = XtNameToWidget(widget, "horizontal");
  vscroll = XtNameToWidget(widget, "vertical");

  event.type = ClientMessage;
  event.xclient.serial = 0;
  event.xclient.send_event = TRUE;
  event.xclient.display = XtDisplay(hscroll);
  event.xclient.window = XtWindow(hscroll);
  event.xclient.message_type = XA_CARDINAL;
  event.xclient.format = 32;

  XtCallActionProc(hscroll, "StartScroll", &event, &scrollback, 1);
  XtCallActionProc(hscroll, "NotifyScroll", &event, &fullscroll, 1);
  XtCallActionProc(hscroll, "EndScroll", &event, (String *) NULL, 0);

  event.xclient.window = XtWindow(vscroll);

  XtCallActionProc(vscroll, "StartScroll", &event, &scrollback, 1);
  XtCallActionProc(vscroll, "NotifyScroll", &event, &fullscroll, 1);
  XtCallActionProc(vscroll, "EndScroll", &event, (String *) NULL, 0);

  XFlush(XtDisplay(form));

  /**************************************************
   *
   * Reset the string attached to callback for
   * mail (etc.) selection.
   *
   */

  if (XtHasCallbacks(select_button, XtNdestroyCallback) == XtCallbackHasSome)
    {
      XtSetArg(args[0], XtNcallback, &callbacks);
      XtGetValues(select_button, args, 1);
      
      XtFree((char *) callbacks[0].closure);
      
      XtRemoveAllCallbacks(select_button, XtNcallback);
      XtRemoveAllCallbacks(select_button, XtNdestroyCallback);
    }

  /**************************************************
   *
   * If this button currently owns the MUA selection,
   * disown it and reset the background
   * 
   */

  if (curr_selection_owner == select_button)
    {
      Atom selection = XInternAtom(dpy, MUA_ADDRESS, False);
      String params;
      
      XtDisownSelection(select_button,
			selection,
			XtLastTimestampProcessed(dpy));
      
      XtCallActionProc(curr_selection_owner, "unset", &event, &params, 0);
      
      curr_selection_owner = NULLWidget;
    }

#ifdef USE_PP

  /**************************************************
   *
   * Convert rfc822mailbox to OR address if no OR
   *  address present.
   *
   */

  if (*or_addr == '\0' && *mail_addr != '\0')
    {
      OR_ptr or;

      if (or_rfc2or(mail_addr, &or) == OK)
	{
	  OR_ptr comp_or;

	  comp_or = or_default(or);
	  or_or2std(comp_or, or_addr, 1);

	  or_free(or);
	  or_free(comp_or);
	}
    }

  /**************************************************
   *
   * If no OR address available then dont allow selection
   * 
   */

  if (*or_addr == '\0')
    {
      XtSetSensitive(select_button, FALSE);
    }
  else
    {
      (void) sprintf(buffer, "%s\n%s\n%s\n%s", name, dn, phone, or_addr);
      
      select_str = copy_string(buffer);

      XtAddCallback(select_button,
		    XtNcallback,
		    selectMailAddress, 
		    (XtPointer) select_str);

      XtAddCallback(select_button,
		    XtNdestroyCallback,
		    DisownDUA,
		    (XtPointer) select_str);

      XtSetSensitive(select_button, TRUE);
    }
#else /* ! USE_PP */
  XtSetSensitive(select_button, FALSE);
#endif /* USE_PP */

  XawFormDoLayout(form, TRUE);
} /* updateReadDisplay */

/*****************************************************************************
 * doRead()
 *
 * 
 *
 ****************************************************************************/

static void doRead(prim_widget, object_id, prim_id, action_id, trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  QE_error_code read_state;
  QCardinal req_id;
  windowObject this_object = win_objects[object_id];
  String strdn;
  
  strdn = this_object->current_entry;

  /**************************************************
   *
   * Initiate the read
   * 
   */

  if (strdn != NULLString && !isnull(*strdn))
    read_state = do_read(strdn, &req_id, NULLStrCell);
  else
    {
      return;
    }

  setStatusMessage(object_id, "Reading entry. Please Wait.");

  switch (read_state)
    {
    case QERR_bad_value_syntax:
      XBell(dpy, 40);
      setStatusMessage(object_id, "Invalid name!");
      return;
      
    case QERR_internal_limit_reached:
      XBell(dpy, 40);
      setStatusMessage(object_id, "Internal limit reached.");
      return;

    default:
      break;
    }

  /**************************************************
   *
   * Record request invocation
   * 
   */

  request_invoked(req_id,
		  DS_READ,
		  gotReadResult,
		  (DSReportCallback) NULL,
		  prim_widget,
		  object_id,
		  prim_id,
		  action_id,
		  trans_list == NULLTransList? trans_list : trans_list->next);
} /* doRead */

/*****************************************************************************
 * doSeeAlsoAction()
 *
 * 
 *
 ****************************************************************************/

void doSeeAlsoAction(prim_widget, object_id, prim_id, action_id, trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  WidgetList prim_insts;

  prim_insts = findPrimitiveInstances(object_id, READ_OUT);

  if (prim_insts != (Widget *) NULL)
    {
      doReadSeeAlso(prim_widget, object_id, prim_id, action_id, trans_list);
      XtFree((char *) prim_insts);
    }
} /* doSeeAlsoAction */

/*****************************************************************************
 * doReadSeeAlso()
 *
 * 
 *
 ****************************************************************************/

static void doReadSeeAlso(prim_widget,
			  object_id,
			  prim_id,
			  action_id,
			  trans_list)
     Widget prim_widget;
     Cardinal object_id;
     Cardinal prim_id;
     actionID action_id;
     translationList trans_list;
{
  caddr_t data;
  Cardinal child_id;
  QE_error_code read_state;
  QCardinal req_id;
  String strdn;

  if (prim_id != READ_OUT)
    return;

  if (XFindContext(dpy,
		   XtWindow(prim_widget),
		   store_attr_cid,
		   &data)
      == XCNOENT)
    return;

  strdn = (String) data;

  /**************************************************
   *
   * Find the window object that'll receive output.
   * 
   */

  (void) findOutputObject(object_id,
			  trans_list->template1_id,
			  trans_list->mode,
			  &child_id);

  /**************************************************
   *
   * Initiate the read
   * 
   */

  if (strdn != NULLString && !isnull(*strdn))
    read_state = do_read(strdn, &req_id, NULLStrCell);
  else
    {
      return;
    }

  setStatusMessage(object_id, "Reading entry, please Wait.");

  switch (read_state)
    {
    case QERR_bad_value_syntax:
      setStatusMessage(object_id, "Invalid entry name!");
      return;
      
    case QERR_internal_limit_reached:
      setStatusMessage(object_id, "Internal limit reached.");
      return;

    default:
      break;
    }

  /**************************************************
   *
   * Record request invocation
   * 
   */

  request_invoked(req_id,
		  DS_READ,
		  gotReadResult,
		  (DSReportCallback) NULL,
		  prim_widget,
		  child_id,
		  prim_id,
		  action_id,
		  trans_list);
} /* doReadSeeAlso */

/*****************************************************************************
 * addNameAndValueStrings()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void addNameAndValueStrings(nameps, 
				   valps,
				   font,
				   this_attr,
				   to_show,
				   maxwidth_ptr, 
				   namewidth_ptr,
				   linecount_ptr)
     PS nameps;
     PS valps;
     XFontStruct *font;
     attrValList this_attr;
     showValue to_show;
     Dimension *maxwidth_ptr;
     Dimension *namewidth_ptr;
     Cardinal *linecount_ptr;
{
  stringCell curr_val;
  String name, value, start, end;
  Dimension tmpwidth, valwidth = 0, maxwidth, namewidth;
  Cardinal linecount;

  extern int ps_printf();

  maxwidth = *maxwidth_ptr;
  namewidth = *namewidth_ptr;
  linecount = *linecount_ptr;

  /**************************************************
   *
   * Get and insert the name of the attribute
   * 
   */

  name = getAttributeName(AttrT_new(this_attr->attr_name->string));
  ps_printf(nameps, "%s:", name);

  tmpwidth = XTextWidth(font, name, strlen(name));
  if (tmpwidth > namewidth)
    namewidth = tmpwidth;

  /**************************************************
   *
   * Now insert the values
   * 
   */

  for (curr_val = this_attr->val_list;
       curr_val != NULLStrCell;
       curr_val = curr_val->next)
    {
      value = curr_val->string;
      
      if ((end = index(value, '\n')) == NULLString)
	{
	  while (isspace(*value)) value++;
	  tmpwidth = XTextWidth(font, value, strlen(value));
	  
	  if (valwidth < tmpwidth && strlen(value) < 52)
	    {
	      valwidth = tmpwidth;
	      ps_printf(valps, "%s\n", value);
	      ps_printf(nameps, "\n");
	      linecount++;
	    }

	  if (maxwidth < valwidth)
	    maxwidth = valwidth;
	}
      else
	{
	  for (start = value;
	       (end = index(start, '\n')) != NULLString;
	       start = ++end)
	    {
	      *end = '\0';
	      
	      while (isspace(*start)) start++;
	      tmpwidth = XTextWidth(font, start, strlen(start));
	      
	      if (valwidth < tmpwidth)
		valwidth = tmpwidth;
	      
	      ps_printf(valps, "%s\n", start);
	      ps_printf(nameps, "\n");
	      linecount++;
	    }
	  
	  for (end = start; !isnull(*end); end++)
	    ;
	  
	  while (isspace(*start)) start++;
	  
	  tmpwidth = XTextWidth(font, start, strlen(start));
	  if (valwidth < tmpwidth)
	    valwidth = tmpwidth;
	  
	  ps_printf(valps, "%s\n", start);
	  ps_printf(nameps, "\n");
	  linecount++;

	  if (maxwidth < valwidth)
	    maxwidth = valwidth;
	}
    }

  ps_printf(nameps, "\n");
  ps_printf(valps, "\n");

  linecount++;

  *maxwidth_ptr = maxwidth;
  *namewidth_ptr = namewidth;
  *linecount_ptr = linecount;
} /* addNameAndValueStrings */

/*****************************************************************************
 * addDnSelectButton()
 *
 * 
 *
 ****************************************************************************/

static void addDnSelectButton(this_attr, object_id, widget, last_ptr)
     attrValList this_attr;
     Cardinal object_id;
     Widget widget;
     Widget *last_ptr;
{
  AttributeType curr_type;
  char buffer[LINESIZE];
  Widget aux_attr, aux_text, types, form;
  int wdth, hght;
  stringCell curr_value;
  String value;
  Cardinal count;
  Arg args[MAXARGS];

  aux_text = *last_ptr;
  aux_attr = NULLWidget;

  form = XtNameToWidget(widget, "readForm");
  types = XtNameToWidget(form, "readTypes");

  curr_type = AttrT_new(this_attr->attr_name->string);

  for (curr_value = this_attr->val_list;
       curr_value != NULLStrCell;
       curr_value = curr_value->next)
    {
      value = XtNewString(curr_value->string);

      if (*value != '\0')
	{
	  /**************************************************
	   *
	   * Create button.
	   * 
	   */

	  count = 0;
	  
	  XtSetArg(args[count], XtNresizable, TRUE); count++;
	  XtSetArg(args[count], XtNvertDistance, 12); count++;

	  if (aux_text == NULLWidget)
	    {
	      XtSetArg(args[count], XtNfromVert, types); count++;
	    }
	  else
	    {
	      XtSetArg(args[count], XtNfromVert, aux_text); count++;
	    }
	  
	  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
	  XtSetArg(args[count], XtNright, XtChainLeft); count++;  
	  
	  XtSetArg(args[count], XtNtop, XtChainBottom); count++;
	  XtSetArg(args[count], XtNbottom, XtChainBottom); count++;

	  XtSetArg(args[count], XtNlabel, getAttributeName(curr_type));count++;
	  aux_attr = XtCreateManagedWidget("attrButton",
					   commandWidgetClass,
					   form,
					   args,
					   count);

	  /**************************************************
	   *
	   * Store DN value and ID of read display.
	   * 
	   */

	  initPrimAction(aux_attr, object_id, ActionUndefined, READ_OUT);
	  XLUaddContextEntry(aux_attr,
			     store_attr_cid,
			     (caddr_t) value,
			     XLUfreeStorage);

	  /**************************************************
	   *
	   * Text field containing UFN.
	   * 
	   */

	  friendlify(value, buffer);
	  count = 0;
	  
	  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;
	  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
	  
	  XtSetArg(args[count], XtNresizable, TRUE); count++;
	  XtSetArg(args[count], XtNstring, buffer); count++;
      
	  XtSetArg(args[count], XtNvertDistance, 12); count++;
	  XtSetArg(args[count], XtNhorizDistance, 20); count++;
	  
	  if (aux_text == NULLWidget)
	    {
	      XtSetArg(args[count], XtNfromVert, types); count++;
	    }
	  else
	    {
	      XtSetArg(args[count], XtNfromVert, aux_text); count++;
	    }
	  
	  XtSetArg(args[count], XtNfromHoriz, aux_attr); count++;
	  
	  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
	  XtSetArg(args[count], XtNright, XtChainLeft); count++;  
	  
	  XtSetArg(args[count], XtNtop, XtChainBottom); count++;
	  XtSetArg(args[count], XtNbottom, XtChainBottom); count++;
	  
	  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
	  XtSetArg(args[count], XtNborderWidth, 0); count++;
	  
	  *last_ptr = aux_text = XtCreateManagedWidget("attrText",
						       asciiTextWidgetClass,
						       form,
						       args,
						       count);

	  /**************************************************
	   *
	   * Make sure text field resizes OK.
	   * 
	   */
      
	  get_text_dims(buffer, aux_text, &hght, &wdth);
	  count = 0;
	  
	  XtSetArg(args[count], XtNwidth, (Dimension) wdth); count++;
	  XtSetArg(args[count], XtNheight, (Dimension) hght); count++;
	  
	  XtSetValues(aux_text, args, count);
	}
    }
} /* addDnSelectButton */

/*****************************************************************************
 * selectMailAddress()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void selectMailAddress(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  String select_str = (String) closure;

  if (select_str == NULLString)
    return;

  last_selection_owner = curr_selection_owner;
  curr_selection_owner = w;

  /***************************************************
   *
   * Own the selection using MUA specific selection.
   *
   */

  (void) OwnMUA(w, ConvertDUA, LoseDUA, (caddr_t) select_str);
} /* SelectMailAddress */

/*****************************************************************************
 * LoseDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static int LoseDUA(data)
     caddr_t data;
{
  XEvent event;
  String params = NULLCP;
      
  if (last_selection_owner != NULLWidget &&
      XtClass(last_selection_owner) == commandWidgetClass)
    {
      XtCallActionProc(last_selection_owner, "unset", &event, &params, 0);
    }
  
  return 1;
} /* LoseDUA */

/*****************************************************************************
 * ConvertDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static int ConvertDUA(data, name_ptr, phone_ptr, dn_ptr, or_ptr)
     caddr_t data;
     String *name_ptr;
     String *phone_ptr;
     String *dn_ptr;
     String *or_ptr;
{
  String start, end;

  *name_ptr = select_name;
  *phone_ptr = select_phone;
  *dn_ptr = select_dn;
  *or_ptr = select_mail;

  end = index((start = (String) data), '\n');
  *end = '\0';
  (void) strcpy(select_name, start);
  *end++ = '\n';
  
  end = index((start = end), '\n');
  *end = '\0';
  (void) strcpy(select_dn, start);
  *end++ = '\n';

  end = index((start = end), '\n');
  *end = '\0';
  (void) strcpy(select_phone, start);
  *end++ = '\n';

  start = end;
  (void) strcpy(select_mail, start);
  
  return 1;
} /* ConvertDUA */

/*****************************************************************************
 * DisownDUA()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void DisownDUA(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Atom selection;
  
  selection = XInternAtom(dpy, MUA_ADDRESS, False);

  if (curr_selection_owner == w)
    {
      XtDisownSelection(w, selection, XtLastTimestampProcessed(dpy));
      curr_selection_owner = NULLWidget;
    }
  else if (last_selection_owner == w)
    last_selection_owner = NULLWidget;

  XtFree((char *) closure);
} /* DisownDUA */

#if defined(sparc) && defined(SUNOS41)

/*****************************************************************************
 * addAudioPlayButton()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void addAudioPlayButton(sound, widget, last_ptr)
     audioData sound;
     Widget widget;
     Widget *last_ptr;
{
  AttributeType audio_type;
  Widget button, form, types;
  Cardinal count;
  Arg args[MAXARGS];

  form = XtNameToWidget(widget, "readForm");
  types = XtNameToWidget(form, "readTypes");

  audio_type = AttrT_new("audio");
  count = 0;

  if (*last_ptr == NULLWidget)
    {
      XtSetArg(args[count], XtNfromVert, types); count++;
    }
  else
    {
      XtSetArg(args[count], XtNfromVert, *last_ptr); count++;
    }
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;  
  
  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  
  XtSetArg(args[count], XtNlabel, getAttributeName(audio_type)); count++;
  
  *last_ptr = button = XtCreateManagedWidget("audioButton",
					     commandWidgetClass,
					     form,
					     args,
					     count);


  XtAddCallback(button, XtNcallback, playAudio, (XtPointer) sound);
  XtAddCallback(button, XtNdestroyCallback, freeAudioData, (XtPointer) sound);
} /* addAudioPlayButton */

/*****************************************************************************
 * playAudio()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void playAudio(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  audioData sound = (audioData) closure;
  Cardinal object_id = get_object_id(w);
  int pd[2];
  char buffer[LINESIZE], execvector[LINESIZE];

  int pid, childpid;
  SFP pstat;

#ifndef BSD42
int     status;
#else
union wait status;
#endif /* BSD42 */

  extern int fork(), pipe(), close(), dup2(),
         _exit(), execl(), read(), write(), fflush(), printf();

  if (pipe(pd) == -1)
    {
      XBell(dpy, 40);
      
      setStatusMessage(object_id, "System error! Can't play sound");
      return;
    }

  pstat = signal(SIGPIPE, SIG_IGN);
  
  switch (childpid = fork())
    {
    case -1:
      
      (void) close (pd[1]);
      (void) close (pd[0]);
      (void) signal (SIGPIPE, pstat);
      
      XBell(dpy, 40);
      
      setStatusMessage(object_id, "System error! Can't play sound");
      return;

    case 0:
      
      (void) signal (SIGPIPE, pstat);
      
      if (dup2(pd[0], 0) == -1)
	_exit (-1);

      (void) close (pd[0]);
      (void) close (pd[1]);
      
      (void) sprintf (execvector, "%splay", BINPATH);
      (void) execl (execvector, execvector, NULLCP);
      
      while (read (0, buffer, sizeof buffer) > 0)
	continue;
      
      (void) printf ("ERROR: can't execute '%s'", execvector);
      (void) fflush (stdout);

      /* safety catch */
      _exit (-1);

      /* NOTREACHED */

    default:

      (void) close (pd[0]);

      setStatusMessage(object_id, "Play audio invoked");
      
      if (write(pd[1], (char *) sound->bytes, sound->length) != sound->length)
	{
	  (void) close (pd[1]);
	  (void) signal (SIGPIPE, pstat);

	  XBell(dpy, 40);

	  setStatusMessage(object_id, "System error! Can't play sound");
	  return;
	}

      (void) close (pd[1]);

      while ((pid = wait(&status)) != NOTOK && childpid != pid)
	continue;
      
      (void) signal (SIGPIPE, pstat);
      
      return;
    }
} /* playAudio */

/*****************************************************************************
 * freeAudioData()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void freeAudioData(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  audioData sound = (audioData) closure;
  
  XtFree((char *) sound->bytes);
  XtFree((char *) sound);
} /* FreeAudioBytes */

#endif /* defined(sparc) && defined(SUNOS41) */
