#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/status.c,v 1.0 92/11/27 17:00:45 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/status.c,v 1.0 92/11/27 17:00:45 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  status.c - Display status messages

*****************************************************************************/

#include "defs.h"

#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>

#include "query.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "ask.h"

#include "status.h"
#include "showentry.h"

/**************************************************
 *
 * Local functions.
 * 
 */

static void closeMessage();

/*****************************************************************************
 * setStatusMessage()
 *
 * 
 *
 ****************************************************************************/

void setStatusMessage(object_id, message)
     Cardinal object_id;
     String message;
{
  WidgetList statuswidgets;
  Widget currstatus;
  Cardinal aindex, count;
  Arg args[MAXARGS];

  if (object_id == MAXWINDOWS)
    return;

  statuswidgets = findPrimitiveInstances(object_id, STATUS);

  if (statuswidgets == (Widget *) NULL)
    {
      XLUmessage(message, object_id);
      return;
    }

  for (aindex = 0, currstatus = statuswidgets[0];
       currstatus != NULLWidget;
       aindex++, currstatus = statuswidgets[aindex])
    {
      count = 0;
      XtSetArg(args[count], XtNlabel, message); count++;
      XtSetValues(currstatus, args, count);
    }

  XtFree((char *) statuswidgets);
} /* setStatusMessage */

/*****************************************************************************
 * XLUmessage()
 *
 * Display a message in a modal window.
 *
 ****************************************************************************/

void XLUmessage(message, parent_id)
     String message;
     Cardinal parent_id;
{
  windowObject this_object;
  Widget parent_shell, label, popup_shell, form, button;
  Arg args[MAXARGS];
  Cardinal count;
  Position x, y;

  extern windowObject win_objects[];
  extern Widget toplevel;

  if (parent_id < MAXWINDOWS)
    {
      this_object = win_objects[parent_id];

      parent_shell = this_object->parent_shell;
      XtTranslateCoords(parent_shell, -20, 20, &x, &y);

      if (x < 0)
	x = 0;
    }
  else
    x = y = 0;

  XBell(XtDisplay(toplevel), 40);

  popup_shell = XtCreatePopupShell("Xlookup status message",
				   transientShellWidgetClass,
				   toplevel,
				   args,
				   0);

  count = 0;
  XtSetArg(args[count], XtNdefaultDistance, 16); count++;
  form = XtCreateManagedWidget("messageForm",
			       formWidgetClass,
			       popup_shell,
			       args,
			       0);
  /**************************************************
   *
   * Message label.
   * 
   */
  
  count = 0;

  XtSetArg(args[count], XtNlabel, message); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNleft, XtChainTop); count++;

  label = XtCreateManagedWidget("messageLabel",
				labelWidgetClass,
				form,
				args,
				count);

  /**************************************************
   *
   * OK button.
   * 
   */

  
  count = 0;
  XtSetArg(args[count], XtNfromVert, label); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  button = XtCreateManagedWidget("messageOkButton",
				 commandWidgetClass,
				 form,
				 args,
				 count);

  XtAddCallback(button, XtNcallback, closeMessage, (XtPointer) NULL);

  XtMoveWidget(popup_shell, x, y);
  XtPopup(popup_shell, XtGrabExclusive); 
} /* XLUmessage */

/*****************************************************************************
 * closeMessage()
 *
 * Callback used to close modal message box.
 *
 ****************************************************************************/

static void closeMessage(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  XtPopdown(XtParent(XtParent(w)));
  XtDestroyWidget(XtParent(XtParent(w)));
} /* closeMessage */
