#ifndef _Xlu_update1_h_
#define _Xlu_update1_h_

#include "configure.h"

/***************************************************
 *
 * Modify form status.
 *
 */

typedef enum {Composing, Modifying, NoEntry} updateState;

typedef struct _update_status
{
  updateState state;
  Boolean changes;
} update_status, *updateStatus;

#define NULLUpdateStatus (updateStatus) NULL
#define update_status_alloc() (updateStatus) XtMalloc(sizeof(update_status))

/***************************************************
 *
 * Data structures used to manipulate
 * and maintain edit fields.
 *
 */

typedef struct _modify_field
{
  Boolean changed;
  Boolean is_active;
  Boolean is_rdn;
  Boolean is_must;

  Widget edit;
  int syntax;

  modifyValue this_value;
  modifyAttr this_attr;

  struct _modify_field *next;
} modify_field, *modifyField;

#define NULLModifyField (modifyField) NULL
#define mod_field_alloc() (modifyField) XtMalloc(sizeof(modify_field))

typedef struct _modify_group
{
  attributeGroup group;
  modifyField fields;

  struct _modify_group *next;
} modify_group, *modifyGroup;

#define NULLModifyGroup (modifyGroup) NULL
#define mod_group_alloc() (modifyGroup) XtMalloc(sizeof(modify_group))

typedef struct _modify_entry
{
  modifyGroup groups;
  modifyAttr undisplayed;
  String name;
  String current_dn;
} modify_entry, *modifyEntry;

#define NULLModifyEntry (modifyEntry) NULL
#define mod_entry_alloc() (modifyEntry) XtMalloc(sizeof(modify_entry))

/***************************************************
 *
 * Public functions.
 *
 */

void initModContexts();
void initModifyStatusData();

void doUpdateModifyForm();
void displayClassTemplate();

void displayEntryTemplate();
void gotEntryTemplateResult();

void displayNextGroup();
void displayPreviousGroup();
void addDialog();

void changeModifyFocus();
void getModifyFocus();

void changeDialogFocus();
void setDialogFocus();

void setUpdateStatus();
void getUpdateStatus();

#endif /* _Xlu_update1_h_ */

